By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. This feature is similar to 'cell merging' in Excel or 'column spanning' in HTML tables.
Configuring Column Spanning Copy Link
Column spanning is configured at the column definition level. To have a cell span more than one column, return how many columns to span in the callback colDef.colSpan.
const gridOptions = {
columnDefs: [
{
field: 'country',
// col span is 2 for rows with Russia, but 1 for everything else
colSpan: params => params.data?.country === 'Russia' ? 2 : 1,
}
],
// other grid options ...
}The interface for the colSpan callback is as follows:
By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. |
Column Spanning Simple Example Copy Link
Below shows an example using column spanning. The example doesn't make much sense, it just arbitrarily sets column span on some cells for demonstration purposes, however we thought it easier to show column spanning with the familiar Olympic winners data before going a bit deeper into its usages. The following can be noted:
- The Country column is configured to span 2 columns when 'Russia' and 4 columns when 'United States'. All other times it's normal (1 column).
- To help demonstrate the spanned column, the Country column is coloured blue using CSS.
- Resizing any columns that are spanned over will also resize the spanned cells. For example, resizing the column immediately to the right of 'Country' will resize all cells spanning over the resized column.
- The first two columns are pinned. If you drag the country column into the pinned area, you will notice that the spanning is constrained within the pinned section, e.g. if you place Country as the last pinned column, no spanning will occur, as the spanning can only happen over cells in the same region, and Country now has no further columns inside the pinned region.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
const columnDefs: ColDef[] = [
{ field: "athlete", pinned: "left" },
{ field: "age", pinned: "left" },
{
field: "country",
colSpan: (params) => {
const country = params.data.country;
if (country === "Russia") {
// have all Russia age columns width 2
return 2;
} else if (country === "United States") {
// have all United States column width 4
return 4;
} else {
// all other rows should be just normal
return 1;
}
},
},
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: columnDefs,
defaultColDef: {
width: 150,
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
.ag-grid-scrolling-rows [col-id='country'] {
background-color: #2244cc44;
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Column Spanning Complex Example Copy Link
Column spanning will typically be used for creating reports with AG Grid. Below is something that would be more typical of the column spanning feature. The following can be noted from the example:
- The data is formatted in a certain way, it is not intended for the user to sort this data or reorder the columns.
- The dataset has meta-data inside it, the
data.sectionattribute. This meta-data, provided by the application, is used in the grid configuration in order to set the column spans and the background colours.
import {
CellClassRules,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColSpanParams,
ColumnAutoSizeModule,
GridApi,
GridOptions,
ModuleRegistry,
RowHeightParams,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnAutoSizeModule,
CellStyleModule,
ClientSideRowModelModule,
]);
const cellClassRules: CellClassRules = {
"header-cell": 'data.section === "big-title"',
"quarters-cell": 'data.section === "quarters"',
};
const columnDefs: ColDef[] = [
{
headerName: "Jan",
field: "jan",
colSpan: (params: ColSpanParams) => {
if (isHeaderRow(params)) {
return 6;
} else if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "Feb", field: "feb" },
{ headerName: "Mar", field: "mar" },
{
headerName: "Apr",
field: "apr",
colSpan: (params: ColSpanParams) => {
if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "May", field: "may" },
{ headerName: "Jun", field: "jun" },
];
let gridApi: GridApi;
const gridOptions: GridOptions = {
getRowHeight: (params: RowHeightParams) => {
if (isHeaderRow(params)) {
return 60;
}
},
columnDefs: columnDefs,
rowData: getData(),
defaultColDef: {
width: 100,
sortable: false,
suppressMovable: true,
},
autoSizeStrategy: {
type: "fitGridWidth",
},
};
function isHeaderRow(params: RowHeightParams | ColSpanParams) {
return params.data.section === "big-title";
}
function isQuarterRow(params: ColSpanParams) {
return params.data.section === "quarters";
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
.header-cell {
background-color: #2244cc44;
font-size: 25px;
font-weight: bold;
text-align: center;
}
.quarters-cell {
background-color: #2244cc44;
font-weight: bold;
}
export function getData(): any[] {
const rowData = [
{ section: 'big-title', jan: 'Warehouse 1' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 534, feb: 612, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 765, feb: 146, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 335, feb: 122, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 35, feb: 342, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 568, feb: 531, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 365, feb: 361, mar: 243, apr: 231, may: 428, jun: 231 },
{ section: 'big-title', jan: 'Warehouse 2' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 2, feb: 32, mar: 24, apr: 31, may: 48, jun: 21 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
];
return rowData;
}
<div id="myGrid" style="height: 100%"></div>
Column Spanning Constraints Copy Link
Column Spanning breaks out of the row / cell calculations that a lot of features in the grid are based on. If using Column Spanning, be aware of the following:
- Cell Selection will not work correctly when spanning cells. This is because it is not possible to cover all scenarios, as a range is no longer a perfect rectangle.
- Column spanning cannot cross pinned region boundaries. A span that would extend from a pinned section into the scrollable area (or vice versa) will be constrained to the current region.
colSpanandspanRowsare mutually exclusive — a column definition cannot use both at the same time.

By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. This feature is similar to 'cell merging' in Excel or 'column spanning' in HTML tables.
Configuring Column Spanning Copy Link
Column spanning is configured at the column definition level. To have a cell span more than one column, return how many columns to span in the callback colDef.colSpan.
<ag-grid-angular
[columnDefs]="columnDefs"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'country',
// col span is 2 for rows with Russia, but 1 for everything else
colSpan: params => params.data?.country === 'Russia' ? 2 : 1,
}
];The interface for the colSpan callback is as follows:
By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. |
Column Spanning Simple Example Copy Link
Below shows an example using column spanning. The example doesn't make much sense, it just arbitrarily sets column span on some cells for demonstration purposes, however we thought it easier to show column spanning with the familiar Olympic winners data before going a bit deeper into its usages. The following can be noted:
- The Country column is configured to span 2 columns when 'Russia' and 4 columns when 'United States'. All other times it's normal (1 column).
- To help demonstrate the spanned column, the Country column is coloured blue using CSS.
- Resizing any columns that are spanned over will also resize the spanned cells. For example, resizing the column immediately to the right of 'Country' will resize all cells spanning over the resized column.
- The first two columns are pinned. If you drag the country column into the pinned area, you will notice that the spanning is constrained within the pinned section, e.g. if you place Country as the last pinned column, no spanning will occur, as the spanning can only happen over cells in the same region, and Country now has no further columns inside the pinned region.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", pinned: "left" },
{ field: "age", pinned: "left" },
{
field: "country",
colSpan: (params) => {
const country = params.data.country;
if (country === "Russia") {
// have all Russia age columns width 2
return 2;
} else if (country === "United States") {
// have all United States column width 4
return 4;
} else {
// all other rows should be just normal
return 1;
}
},
},
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
width: 150,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-grid-scrolling-rows [col-id='country'] {
background-color: #2244cc44;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Column Spanning Complex Example Copy Link
Column spanning will typically be used for creating reports with AG Grid. Below is something that would be more typical of the column spanning feature. The following can be noted from the example:
- The data is formatted in a certain way, it is not intended for the user to sort this data or reorder the columns.
- The dataset has meta-data inside it, the
data.sectionattribute. This meta-data, provided by the application, is used in the grid configuration in order to set the column spans and the background colours.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
AutoSizeStrategy,
CellClassRules,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColSpanParams,
ColumnAutoSizeModule,
GetRowHeight,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowHeightParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnAutoSizeModule,
CellStyleModule,
ClientSideRowModelModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[getRowHeight]="getRowHeight"
[rowData]="rowData"
[defaultColDef]="defaultColDef"
[autoSizeStrategy]="autoSizeStrategy"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
headerName: "Jan",
field: "jan",
colSpan: (params: ColSpanParams) => {
if (isHeaderRow(params)) {
return 6;
} else if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "Feb", field: "feb" },
{ headerName: "Mar", field: "mar" },
{
headerName: "Apr",
field: "apr",
colSpan: (params: ColSpanParams) => {
if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "May", field: "may" },
{ headerName: "Jun", field: "jun" },
];
getRowHeight: GetRowHeight = (params: RowHeightParams) => {
if (isHeaderRow(params)) {
return 60;
}
};
rowData: any[] | null = getData();
defaultColDef: ColDef = {
width: 100,
sortable: false,
suppressMovable: true,
};
autoSizeStrategy: AutoSizeStrategy = {
type: "fitGridWidth",
};
}
const cellClassRules: CellClassRules = {
"header-cell": 'data.section === "big-title"',
"quarters-cell": 'data.section === "quarters"',
};
function isHeaderRow(params: RowHeightParams | ColSpanParams) {
return params.data.section === "big-title";
}
function isQuarterRow(params: ColSpanParams) {
return params.data.section === "quarters";
}
.header-cell {
background-color: #2244cc44;
font-size: 25px;
font-weight: bold;
text-align: center;
}
.quarters-cell {
background-color: #2244cc44;
font-weight: bold;
}
export function getData(): any[] {
const rowData = [
{ section: 'big-title', jan: 'Warehouse 1' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 534, feb: 612, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 765, feb: 146, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 335, feb: 122, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 35, feb: 342, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 568, feb: 531, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 365, feb: 361, mar: 243, apr: 231, may: 428, jun: 231 },
{ section: 'big-title', jan: 'Warehouse 2' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 2, feb: 32, mar: 24, apr: 31, may: 48, jun: 21 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
];
return rowData;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Column Spanning Constraints Copy Link
Column Spanning breaks out of the row / cell calculations that a lot of features in the grid are based on. If using Column Spanning, be aware of the following:
- Cell Selection will not work correctly when spanning cells. This is because it is not possible to cover all scenarios, as a range is no longer a perfect rectangle.
- Column spanning cannot cross pinned region boundaries. A span that would extend from a pinned section into the scrollable area (or vice versa) will be constrained to the current region.
colSpanandspanRowsare mutually exclusive — a column definition cannot use both at the same time.

By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. This feature is similar to 'cell merging' in Excel or 'column spanning' in HTML tables.
Configuring Column Spanning Copy Link
Column spanning is configured at the column definition level. To have a cell span more than one column, return how many columns to span in the callback colDef.colSpan.
const [columnDefs, setColumnDefs] = useState([
{
field: 'country',
// col span is 2 for rows with Russia, but 1 for everything else
colSpan: params => params.data?.country === 'Russia' ? 2 : 1,
}
]);
<AgGridReact columnDefs={columnDefs} />The interface for the colSpan callback is as follows:
By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. |
Column Spanning Simple Example Copy Link
Below shows an example using column spanning. The example doesn't make much sense, it just arbitrarily sets column span on some cells for demonstration purposes, however we thought it easier to show column spanning with the familiar Olympic winners data before going a bit deeper into its usages. The following can be noted:
- The Country column is configured to span 2 columns when 'Russia' and 4 columns when 'United States'. All other times it's normal (1 column).
- To help demonstrate the spanned column, the Country column is coloured blue using CSS.
- Resizing any columns that are spanned over will also resize the spanned cells. For example, resizing the column immediately to the right of 'Country' will resize all cells spanning over the resized column.
- The first two columns are pinned. If you drag the country column into the pinned area, you will notice that the spanning is constrained within the pinned section, e.g. if you place Country as the last pinned column, no spanning will occur, as the spanning can only happen over cells in the same region, and Country now has no further columns inside the pinned region.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", pinned: "left" },
{ field: "age", pinned: "left" },
{
field: "country",
colSpan: (params) => {
const country = params.data.country;
if (country === "Russia") {
// have all Russia age columns width 2
return 2;
} else if (country === "United States") {
// have all United States column width 4
return 4;
} else {
// all other rows should be just normal
return 1;
}
},
},
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 150,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-grid-scrolling-rows [col-id='country'] {
background-color: #2244cc44;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Column Spanning Complex Example Copy Link
Column spanning will typically be used for creating reports with AG Grid. Below is something that would be more typical of the column spanning feature. The following can be noted from the example:
- The data is formatted in a certain way, it is not intended for the user to sort this data or reorder the columns.
- The dataset has meta-data inside it, the
data.sectionattribute. This meta-data, provided by the application, is used in the grid configuration in order to set the column spans and the background colours.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
AutoSizeStrategy,
CellClassRules,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColSpanParams,
ColumnAutoSizeModule,
GetRowHeight,
GridApi,
GridOptions,
ModuleRegistry,
RowHeightParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ColumnAutoSizeModule,
CellStyleModule,
ClientSideRowModelModule,
];
const cellClassRules: CellClassRules = {
"header-cell": 'data.section === "big-title"',
"quarters-cell": 'data.section === "quarters"',
};
function isHeaderRow(params: RowHeightParams | ColSpanParams) {
return params.data.section === "big-title";
}
function isQuarterRow(params: ColSpanParams) {
return params.data.section === "quarters";
}
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
headerName: "Jan",
field: "jan",
colSpan: (params: ColSpanParams) => {
if (isHeaderRow(params)) {
return 6;
} else if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "Feb", field: "feb" },
{ headerName: "Mar", field: "mar" },
{
headerName: "Apr",
field: "apr",
colSpan: (params: ColSpanParams) => {
if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "May", field: "may" },
{ headerName: "Jun", field: "jun" },
]);
const getRowHeight = useCallback((params: RowHeightParams) => {
if (isHeaderRow(params)) {
return 60;
}
}, []);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 100,
sortable: false,
suppressMovable: true,
};
}, []);
const autoSizeStrategy = useMemo<AutoSizeStrategy>(() => {
return {
type: "fitGridWidth",
};
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
getRowHeight={getRowHeight}
defaultColDef={defaultColDef}
autoSizeStrategy={autoSizeStrategy}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.header-cell {
background-color: #2244cc44;
font-size: 25px;
font-weight: bold;
text-align: center;
}
.quarters-cell {
background-color: #2244cc44;
font-weight: bold;
}
export function getData(): any[] {
const rowData = [
{ section: 'big-title', jan: 'Warehouse 1' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 534, feb: 612, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 765, feb: 146, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 335, feb: 122, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 35, feb: 342, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 568, feb: 531, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 365, feb: 361, mar: 243, apr: 231, may: 428, jun: 231 },
{ section: 'big-title', jan: 'Warehouse 2' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 2, feb: 32, mar: 24, apr: 31, may: 48, jun: 21 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
];
return rowData;
}
Column Spanning Constraints Copy Link
Column Spanning breaks out of the row / cell calculations that a lot of features in the grid are based on. If using Column Spanning, be aware of the following:
- Cell Selection will not work correctly when spanning cells. This is because it is not possible to cover all scenarios, as a range is no longer a perfect rectangle.
- Column spanning cannot cross pinned region boundaries. A span that would extend from a pinned section into the scrollable area (or vice versa) will be constrained to the current region.
colSpanandspanRowsare mutually exclusive — a column definition cannot use both at the same time.

By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. This feature is similar to 'cell merging' in Excel or 'column spanning' in HTML tables.
Configuring Column Spanning Copy Link
Column spanning is configured at the column definition level. To have a cell span more than one column, return how many columns to span in the callback colDef.colSpan.
<ag-grid-vue
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'country',
// col span is 2 for rows with Russia, but 1 for everything else
colSpan: params => params.data?.country === 'Russia' ? 2 : 1,
}
];The interface for the colSpan callback is as follows:
By default, each cell will take up the width of one column. You can change this behaviour to allow cells to span multiple columns. |
Column Spanning Simple Example Copy Link
Below shows an example using column spanning. The example doesn't make much sense, it just arbitrarily sets column span on some cells for demonstration purposes, however we thought it easier to show column spanning with the familiar Olympic winners data before going a bit deeper into its usages. The following can be noted:
- The Country column is configured to span 2 columns when 'Russia' and 4 columns when 'United States'. All other times it's normal (1 column).
- To help demonstrate the spanned column, the Country column is coloured blue using CSS.
- Resizing any columns that are spanned over will also resize the spanned cells. For example, resizing the column immediately to the right of 'Country' will resize all cells spanning over the resized column.
- The first two columns are pinned. If you drag the country column into the pinned area, you will notice that the spanning is constrained within the pinned section, e.g. if you place Country as the last pinned column, no spanning will occur, as the spanning can only happen over cells in the same region, and Country now has no further columns inside the pinned region.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", pinned: "left" },
{ field: "age", pinned: "left" },
{
field: "country",
colSpan: (params) => {
const country = params.data.country;
if (country === "Russia") {
// have all Russia age columns width 2
return 2;
} else if (country === "United States") {
// have all United States column width 4
return 4;
} else {
// all other rows should be just normal
return 1;
}
},
},
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
width: 150,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-grid-scrolling-rows [col-id='country'] {
background-color: #2244cc44;
}
Column Spanning Complex Example Copy Link
Column spanning will typically be used for creating reports with AG Grid. Below is something that would be more typical of the column spanning feature. The following can be noted from the example:
- The data is formatted in a certain way, it is not intended for the user to sort this data or reorder the columns.
- The dataset has meta-data inside it, the
data.sectionattribute. This meta-data, provided by the application, is used in the grid configuration in order to set the column spans and the background colours.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
AutoSizeStrategy,
CellClassRules,
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColSpanParams,
ColumnAutoSizeModule,
GetRowHeight,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowHeightParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnAutoSizeModule,
CellStyleModule,
ClientSideRowModelModule,
]);
const cellClassRules: CellClassRules = {
"header-cell": 'data.section === "big-title"',
"quarters-cell": 'data.section === "quarters"',
};
function isHeaderRow(params: RowHeightParams | ColSpanParams) {
return params.data.section === "big-title";
}
function isQuarterRow(params: ColSpanParams) {
return params.data.section === "quarters";
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:getRowHeight="getRowHeight"
:rowData="rowData"
:defaultColDef="defaultColDef"
:autoSizeStrategy="autoSizeStrategy"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
headerName: "Jan",
field: "jan",
colSpan: (params: ColSpanParams) => {
if (isHeaderRow(params)) {
return 6;
} else if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "Feb", field: "feb" },
{ headerName: "Mar", field: "mar" },
{
headerName: "Apr",
field: "apr",
colSpan: (params: ColSpanParams) => {
if (isQuarterRow(params)) {
return 3;
} else {
return 1;
}
},
cellClassRules: cellClassRules,
},
{ headerName: "May", field: "may" },
{ headerName: "Jun", field: "jun" },
]);
const getRowHeight = ref<GetRowHeight>((params: RowHeightParams) => {
if (isHeaderRow(params)) {
return 60;
}
});
const rowData = ref<any[] | null>(getData());
const defaultColDef = ref<ColDef>({
width: 100,
sortable: false,
suppressMovable: true,
});
const autoSizeStrategy = ref<AutoSizeStrategy>({
type: "fitGridWidth",
});
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
getRowHeight,
rowData,
defaultColDef,
autoSizeStrategy,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.header-cell {
background-color: #2244cc44;
font-size: 25px;
font-weight: bold;
text-align: center;
}
.quarters-cell {
background-color: #2244cc44;
font-weight: bold;
}
export function getData(): any[] {
const rowData = [
{ section: 'big-title', jan: 'Warehouse 1' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 534, feb: 612, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 765, feb: 146, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 335, feb: 122, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 35, feb: 342, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 568, feb: 531, mar: 243, apr: 231, may: 428, jun: 231 },
{ jan: 365, feb: 361, mar: 243, apr: 231, may: 428, jun: 231 },
{ section: 'big-title', jan: 'Warehouse 2' },
{ section: 'quarters', jan: 'Q1', apr: 'Q2' },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
{ jan: 2, feb: 32, mar: 24, apr: 31, may: 48, jun: 21 },
{ jan: 21, feb: 12, mar: 24, apr: 31, may: 28, jun: 31 },
];
return rowData;
}
Column Spanning Constraints Copy Link
Column Spanning breaks out of the row / cell calculations that a lot of features in the grid are based on. If using Column Spanning, be aware of the following:
- Cell Selection will not work correctly when spanning cells. This is because it is not possible to cover all scenarios, as a range is no longer a perfect rectangle.
- Column spanning cannot cross pinned region boundaries. A span that would extend from a pinned section into the scrollable area (or vice versa) will be constrained to the current region.
colSpanandspanRowsare mutually exclusive — a column definition cannot use both at the same time.